C************************************
C     MODULE 2
C************************************
C234567
      SUBROUTINE ASSIGN
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/REFLS/IREFS(IRS),REFS(IRS,3),MLT(IRS),PHASEN(IRS),IC(8)
     } ,HALFL(IRS),HALFG(IRS),GAM(IRS)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1
      CHARACTER TITLE*70,PHSNM(8)*70
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ)
     *,IWW(IDSZ),NPTS
      DIMENSION KRR(2,IDSZ)
      ICX=0
      DO 4100 J =1,NPHASE
4100  ICX = ICX + IC(J)
      IF(NPHASE.GT.1)CALL SORT(1000)
      DO 2 J=1,2
      DO 2 K=1,IDSZ
   2  KRR(J,K)=0
      IF(LST3.EQ.0)GOTO 7
      DO 8 I=1,ICX
      IRL=MOD(IREFS(I),256)-128
      IRK=MOD(IREFS(I)/256,256)-128
      IRH=MOD(IREFS(I)/256/256,256)-128
      IRC=MOD(IREFS(I)/256/256/256,8)
      IPHAS=IREFS(I)/256/256/256/8
      IF(MOD(I-1,60).EQ.0)WRITE(6,9)
    8 WRITE(6,10)I,IRC,IRH,IRK,IRL,IPHAS,(REFS(I,JX),JX=1,2)
    9 FORMAT(38H1NO.  CODE    H   K   L  PHASE  HW       ,
     *16HPOSN              /)
   10 FORMAT(1X,2I4,3X,3I4,I6,2F8.3)
    7 DO 479 I=1,ICX
      RMIN=REFS(I,2)-WDT*REFS(I,1)
      RMAX=REFS(I,2)+WDT*REFS(I,1)
      MIN=(RMIN-THMIN)/STEP+1.5
      MAX=(RMAX-THMIN)/STEP+1.5
      MIN=MAX0(MIN,1)
      MIN=MIN0(MIN,NPTS)
      MAX=MIN0(MAX,NPTS)
      DO 479 K=MIN,MAX
      KRR(2,K)=I
 479  IF(KRR(1,K).EQ.0)KRR(1,K)=I
      DO 482 J=1,NEXCRG
      IF(AHIGH(J).LE.THMIN)GOTO 482
      IN1=(ALOW(J)-THMIN)/STEP+1.5
      IN1=MAX0(IN1,1)
      IN2=(AHIGH(J)-THMIN)/STEP+1.5
      IN2=MIN0(IN2,NPTS)
      DO 483 I=IN1,IN2
      KRR(2,I)=1
 483  KRR(1,I)=0
      IF(IN2.EQ.NPTS)GOTO 484
 482  CONTINUE
 484  IF(LST2.EQ.0)GOTO 530
      WRITE(6,589)THMIN,THMAX,STEP
 589  FORMAT(13H1PATTERN FROM,F8.4,1X,2HTO,F8.4,1X,11HIN STEPS OF,
     *F8.4,1X,7HDEGREES)
      WRITE(6,544)
 544  FORMAT(6H0 POSN,6X,3HI+B,5X,1HB,5X,1HI,2X,5H100*W,6X,3HK11,2X,
     *3HK21)
      DO 520 J=1,NPTS
      PX=THMIN+FLOAT(J-1)*STEP
      YUN=Y(J)-BK(J)
      WT=1./VAR(J)
      WRITE(6,559)PX,Y(J),BK(J),YUN,WT,(KRR(J2,J),J2=1,2)
 559  FORMAT(1X,F8.4,3F7.0,2PF9.4,2I5)
  520 CONTINUE
 530  CONTINUE
      DO 600 I=1,NPTS
      IF(KRR(2,I)-KRR(1,I).GT.NOV)THEN
       WRITE(7,601) I,KRR(2,I)-KRR(1,I),NOV
       WRITE(6,601) I,KRR(2,I)-KRR(1,I),NOV
  601 FORMAT(1X,'EXCESSIVE PEAK OVERLAP',/,
     } 5X,'AT THE',I5,'TH STEP THERE ARE ',I5,' REFLECTIONS',/,
     } 5X,'INCREASE THE VALUE OF *NOV* WHICH IS NOW',I5/)
       STOP 'EXCESSIVE PEAK OVERLAP'
      ENDIF
  600 CONTINUE
      DO 531 I=1,NPTS
      KR(I)=KRR(1,I)+IRS *KRR(2,I)
 531  CONTINUE
      DO 602 I=1,NPTS
      IF(KR(I).NE.0.AND.KR(I).NE.IRS )GOTO 603
  602 CONTINUE
      STOP 'NO REFLECTIONS FOUND '
C THE FOLLOWING TEST IS REALLY ONLY VALID FOR THE SINGLE PHASE CASE
  603 IF(REFS(KRR(1,I),2).GE.RLIM.AND.LPAR(1,14).NE.0)THEN
       WRITE(6,604)
       WRITE(7,604)
  604 FORMAT(1X,'ASYMMETRY PARAMETER USAGE INVALID')
       STOP 'ASYMMETRY PARAMETER USAGE INVALID'
      ENDIF
      DO 606 I=1,NPHASE
      IF(PAR(I,12).EQ.0..AND.PAR(I,13).EQ.0..AND.LPAR(I,13).NE.0)THEN
       WRITE(6,605)
       WRITE(7,605)
  605 FORMAT(1X,'PREFERRED ORIENTATION USAGE INVALID')
       STOP 'PREFERRED ORIENTATION USAGE INVALID'
      ENDIF
  606 CONTINUE
      RETURN
      END
      SUBROUTINE CHISQ
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEVINC,YINV,DW
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ)
     *,IWW(IDSZ),NPTS
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      S1=0.
      S2=0.
      D1=0.
      D2=0.
      S3=0.
      DEVINC=0.0
      YINV=0.0
      DW=0.0
      IPASS=0
      DO 10 I=1,NPTS
      IF((NBCKGD.NE.0.AND.KR(I).EQ.0).OR.KR(I).EQ.IRS )GOTO 10
      IF(NEXCRG.GT.0) THEN
       DO 1400 IEXC=1,NEXCRG
       NPTLOW = (ALOW(IEXC)-THMIN)/STEP + 1.5
       NPTHI  = (AHIGH(IEXC)-THMIN)/STEP + 1.5
       IF (I.GE.NPTLOW.AND.I.LE.NPTHI) GO TO 10
1400   CONTINUE
      END IF
      IPASS=IPASS+1
      YY=YC(I)+BK(I)
      IF(YY.LT.0.0000001)YY=0.0000001
      DEL=Y(I)-YY
      DELV=DEL/SQRT(VAR(I))
      IF(IPASS.GT.1) DW=DW+(DELV-DELV1)**2
      DEL1=DELV
      DL=Y(I)*ALOG(Y(I)/YY)-DEL
      DEVINC=DEVINC+DL
      YINV=YINV+1.0/YY      
      S1=S1+ABS(DEL)
      S2=S2+DEL*DEL/VAR(I)
   10 CONTINUE
      DEVINC=2.0*DEVINC
      YINV=YINV/6.0
      DW=DW/S2
      DO 15 I=1,NPTS
      IF((NBCKGD.NE.0.AND.KR(I).EQ.0).OR.KR(I).EQ.IRS )GOTO 15
      IF(NEXCRG.GT.0) THEN
       DO 1401 IEXC=1,NEXCRG
       NPTLOW = (ALOW(IEXC)-THMIN)/STEP + 1.5
       NPTHI  = (AHIGH(IEXC)-THMIN)/STEP + 1.5
       IF (I.GE.NPTLOW.AND.I.LE.NPTHI) GO TO 15
1401   CONTINUE
      END IF
      D1=D1+Y(I)
      D2=D2+Y(I)*Y(I)/VAR(I)
      S3=S3+BK(I)+YC(I)
   15 CONTINUE
      R1=0
      R2=100.*S1/D1
      R3=100.*SQRT(S2/D2)
      RETURN
      END
      SUBROUTINE ITER
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/F1/RJAC(MSZ,MSZ),VX(MSZ)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEVINC,YINV,DW
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1
      CHARACTER TITLE*70,PHSNM(8)*70
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER*4 NAM(16)
      COMMON/COEFC/NAM
C&    COMMON/CONSTR/CONA(2,16,8),ICON(2,16,8),JCON(2,16,8),LCONI(2,16,8)
C&   *,LCONJ(2,16,8),DF(2,16),LN(2,16)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ)
     *,IWW(IDSZ),NPTS
      COMMON/G3/COND,IORD1,IORD2,TH,NUM
      DIMENSION RJ(MSZ,MSZ),VLAST(MSZ)
      EQUIVALENCE (RJ(1,1),KR(1))
      ICONDI=0
      DO 70 I=1,MAXS
   70 VLAST(I)=0.
      DO 10 IX=1,MCYCLE
      CALL ASSIGN
      DO 1 I=1,MAXS
      VX(I)=0.
      DO 1 J=1,MAXS
   1  RJAC(I,J)=0.
      NUM=0
      IPREV=1
      IF(NBCKGD.NE.0)GOTO 30
      TH=THMIN-STEP
      DO 31 I=1,NPTS
      TH=TH+STEP
      THX=TH/BKPOS-1.
      BK(I)=GLB(2)
      DO 31 J=2,6
   31 BK(I)=BK(I)+GLB(J+1)*THX**(J-1)
   30 TH=THMIN-STEP
      DO 9 IPM=1,NPTS
      TH=TH+STEP
      IF(KR(IPM).EQ.IRS )GOTO 9
      IORD1=MOD(KR(IPM),IRS )
      IORD2=MOD(KR(IPM)/IRS ,IRS )
      IF((IORD2.EQ.0.OR.IORD1.EQ.0).AND.NBCKGD.NE.0)GOTO 9
C     IF (IX.EQ.1) GOTO 15
C     IF ((IORD2-IORD1).LT.NOV) GOTO 15
C     WRITE (6,1234) IORD2-IORD1,NOV,IPM
C1234 FORMAT(1X,'NO.OF REFLECTIONS IS ',I4,2X,'AT STEP NO.',I6)
C     STOP
   15 NUM=NUM+1
      IF(IPREV.GT.IORD2)GOTO 40
      DO 21 J=IPREV,IORD2
   21 CALL CALCUL(J)
   40 IPREV=MAX0(IPREV,IORD2+1)
  108 CALL SUMMAT(IPM)
    9 CONTINUE
      IF(JOBTYP.GT.2)RETURN
      DO 50 I=1,MAXS
      DO 50 J=I,MAXS
   50 RJAC(J,I)=RJAC(I,J)
      COND=DPINV(RJAC(1,1),VX(1),MAXS)
      CALL CHISQ
      OOM=S2/FLOAT(NUM-MAXS)
      DO 55 I=1,MAXS
      DO 55 J=1,MAXS
   55 RJAC(I,J)=RJAC(I,J)*OOM
C CODE TO ATTEMPT TO STABILIZE OSCILLATIONS
      DO 60 I=1,MAXS
      IF(SIGN(1.,VX(I)).EQ.SIGN(1.,VLAST(I)))GOTO 60
      IF(ABS(VX(I)).GT.1.2*ABS(VLAST(I)))GOTO 60
      IF(ABS(VX(I)).LT..8*ABS(VLAST(I)))GOTO 60
      VX(I)=VX(I)/2.
   60 VLAST(I)=VX(I)
C
C
C MODIFICATION TO CONTROL THE CONVERGENCE. WHEN CONVERGENCE REACHED THEN
C ICONDI=123, NEW CALCUL OF YC AND R-FACTORS FOR THE VALUES OF PARAMETERS
C AND EXIT TO THE MAIN PROGRAM
C
C
      CALL OUTPTR(IX,ICONDI)
      DO 5 I=1,MAXS
      X1=SQRT(ABS(RJAC(I,I)))*EPS
      IF(ABS(VX(I)).GT.X1.OR.IX.EQ.MCYCLE)GOTO 10
   5  CONTINUE
      ICONDI=123
      CALL CHISQ
      CALL OUTPTR(IX,ICONDI)
      IF (MAXS.GT.0) WRITE (6,1111)
1111  FORMAT(/,10X,'***** EPSED OUT *****'/)
      GOTO 20
  10  CONTINUE
   20 DO 6 I=1,MAXS
      DO 6 J=1,MAXS
   6  RJ(I,J)=RJAC(I,J)
      RETURN
      END
      FUNCTION DPINV(A1,B1,N)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      DOUBLE PRECISION A,B,U,T
      DIMENSION A(MSZ,MSZ),A1(MSZ,MSZ),B(MSZ),B1(MSZ),U(MSZ),M(MSZ)
      IF(N.NE.1)GOTO 50
      A1(1,1)=1./A1(1,1)
      B1(1)=B1(1)*A1(1,1)
      DPINV=1
      GOTO 99
   50 DPINV=0
      DO 1 I=1,N
      B(I)=B1(I)
      DO 1 J=1,N
    1 A(I,J)=A1(I,J)
      DO 2 I=1,N
      U(I)=DABS(A(I,1))
      C=U(I)
      DO 3 J=2,N
      U(I)=DMAX1(U(I),DABS(A(I,J)))
    3 C=C+DABS(A(I,J))
      DPINV=AMAX1(DPINV,C)
      M(I)=I
      B(I)=B(I)/U(I)
      DO 2 J=1,N
    2 A(I,J)=A(I,J)/U(I)
      DO 10 I=1,N
      IF(I.EQ.N)GOTO 15
      J=I
      I1=I+1
      MI=M(I)
      S=DABS(A(MI,I))
      DO 4 K=I1,N
      MI=M(K)
      IF(DABS(A(MI,I)).LE.S)GOTO 4
      S=DABS(A(MI,I))
      J=K
    4 CONTINUE
      MK1=M(J)
      M(J)=M(I)
      M(I)=MK1
   15 MI1=M(I)
      A(MI1,I)=1./A(MI1,I)
      B(MI1)=B(MI1)*A(MI1,I)
      DO 20 J=1,N
      IF(I.EQ.J)GOTO 20
      A(MI1,J)=A(MI1,J)*A(MI1,I)
   20 CONTINUE
      DO 30 J=1,N
      IF(J.EQ.I)GOTO 30
      MJ=M(J)
      T=A(MJ,I)
      MI1=M(I)
      B(MJ)=B(MJ)-T*B(MI1)
      A(MJ,I)=-T*A(MI1,I)
      DO 40 K=1,N
      IF(K.EQ.I)GOTO 40
      A(MJ,K)=A(MJ,K)-T*A(MI1,K)
   40 CONTINUE
   30 CONTINUE
   10 CONTINUE
      DO 93 I=1,N
      MI1=M(I)
      B1(I)=B(MI1)
      DO 94 J=1,N
      MJ=M(J)
   94 A1(I,MJ)=A(MI1,J)/U(MJ)
   93 CONTINUE
      C=0
      DO 91 I=1,N
      D=ABS(A1(I,1))
      DO 92 J=2,N
   92 D=D+ABS(A1(I,J))
   91 C=AMAX1(C,D)
      DPINV=DPINV*C
   99 RETURN
      END
      SUBROUTINE CALCUL(NN)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      REAL LAMDA
      INTEGER PTR
      COMMON/REFLS/IREFS(IRS),REFS(IRS,3),FF(IRS),PHASEN(IRS),IC(8)
     } ,HALFL(IRS),HALFG(IRS),GAM(IRS)
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          SBX,WDT,ULOR,VLOR
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1
      CHARACTER TITLE*70,PHSNM(8)*70
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER*4 NAM(16)
      COMMON/COEFC/NAM
C&    COMMON/CONSTR/CONA(2,16,8),ICON(2,16,8),JCON(2,16,8),LCONI(2,16,8)
C&   *,LCONJ(2,16,8),DF(2,16),LN(2,16)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ)
     *,IWW(IDSZ),NPTS
      COMMON/RTMTX/IVEC(8,192),MLT(8),ICET(8)
      COMMON/G4/TANN(NOV),DERSTO(NOV,MSZ)
      DIMENSION HNN(3),XI(14)
      DIMENSION DERIV(MSZ),SNX(NATS),SINTL(NOV),SA(NATS),SB(NATS)
      DIMENSION TEMP(NATS),SNEX(NATS),T(3),SUMAX(NATS,9),SUMBX(NATS,9)
      DIMENSION H(3),AL(3,3),SM(3,3)
      LOGICAL VERT,SKIP,PAC
      PI=360./3.14159265359
      IPH=IREFS(NN)/256/256/256/8
      IOF=0
      IF(IPH.GT.1)IOF=NATOM(1)
      IRL=MLT(IPH)
      N=NATOM(IPH)
      ICENT=ICET(IPH)
C-----ZEROIZE THE DERIVATIVES OF THIS REFLECTION W.R.T. TO PARAMETERS
      NX=0
      DO 4310 IIPHAS=1,NPHASE
4310  NX=NX+NATOM(IIPHAS)
      DO 12 I=1,MSZ
   12 DERIV(I)=0.
      DO 21 I=1,NX
      DO 21 J=1,9
      SUMBX(I,J)=0.
   21 SUMAX(I,J)=0.
      CV=0.
      DV=0.
      AV=0.
      BV=0.
      PAC=PAR(IPH,12).NE.0.0.OR.LPAR(IPH,12).NE.0
     *.OR.PAR(IPH,13).NE.0.0.OR.LPAR(IPH,13).NE.0
      DO 303 I=1,3
 303  AL(I,I)=PAR(IPH,I+5)
      AL(2,3)=PAR(IPH,9)
      AL(1,3)=PAR(IPH,10)
      AL(1,2)=PAR(IPH,11)
      AH=PAR(IPH,3)
      BH=PAR(IPH,4)
      CH=PAR(IPH,5)
      IF (NPROF.EQ.8) THEN
       AH2=PAR(IPH,15)
       BH2=PAR(IPH,16)
      END IF
      B1=PAR(IPH,12)
      B2=PAR(IPH,13)
      NM=MOD(NN,NOV)+1
      ICX=MOD(IREFS(NN)/256/256/256,8)
      SLABDA=LAMDA(ICX)*LAMDA(ICX)/4.
      N=NATOM(IPH)
      FF(NN)=0.
      PAKNN=0.
      PRECOR=1.
      TR=0.
      HNN(3)=MOD(IREFS(NN),256)-128
      HNN(2)=MOD(IREFS(NN)/256,256)-128
      HNN(1)=MOD(IREFS(NN)/256/256,256)-128
      DO 1 I=1,3
    1 H(I)=HNN(I)
C-----CALCULATION OF TEMP.FACTOR,POSITION AND HALFWIDTH
      SS=0.
      DO 2 I=1,3
      DO 2 J=I,3
    2 SS=AL(I,J)*HNN(I)*HNN(J)+SS
      IF(.NOT.PAC)GOTO 13
      TT=0.
      DO 16 I=1,3
      DO 16 J=I,3
   16 TT=TT+AL(I,J)*PREF(IPH,I)*PREF(IPH,J)
      PAK=0.
      DO 33 I=1,3
      DO 33 J=I,3
   33 PAK=AL(I,J)*(PREF(IPH,I)*HNN(J)+PREF(IPH,J)*HNN(I))/2.+PAK
      PAK=PAK*PAK/(TT*SS)
C
C INTRODUCTION OF THE MARCH'S MODEL FOR PREFERED ORIENTATION
C
      IF (NORI.EQ.1) THEN
        IF (B1.LE.0.0) B1 = 1.0
        SPAK = ABS(1.-PAK)
        PAKNN = B1*B1*PAK+SPAK/B1
        PREDEV = 2.0*B1*PAK-SPAK/B1/B1
        PRECOR = 1.0/PAKNN**1.5
      ELSE IF (NORI.EQ.2) THEN
C
C INTRODUCTION OF THE PECHARSKII'S MODEL FOR PREFERED ORIENTATION
C
      ELSE IF (NORI.EQ.0) THEN
C
C STANDARD MODEL FOR PREFERED ORIENTATION
C
        PAKNN=1.57079633268**2
        IF(PAK.NE.0)PAKNN=ATAN(SQRT(ABS((1.-PAK)/PAK)))**2
        PREXP=EXP(B1*PAKNN)
        PRECOR=B2+(1.-B2)*PREXP
      ELSE
        STOP 'GREATER THAN PARAMETER LIMIT'
      ENDIF
   13 SINTL(NM)=SQRT(SS)
      SSNN=0.25*SS
      TAV=EXP(-2.*PAR(IPH,2)*SSNN)*PRECOR
      SINTH=SLABDA*SS
      COSTH=1.-SINTH
      TANTH=SQRT(SINTH/COSTH)
      TANN(NM)=TANTH
      REFS(NN,2)=ATAN(TANTH)*PI
      HALFG(NN) =     (AH*TANTH*TANTH+BH*TANTH+CH)
      IF (HALFG(NN).GT.0.) THEN
          HALFG(NN) = SQRT(HALFG(NN))
       ELSE
          WRITE (6,3456) REFS(NN,2),IPH
          WRITE (7,3456) REFS(NN,2),IPH
          STOP 'SQUARE OF FWHM IS NEGATIVE'
3456      FORMAT (3X,'SQUARE OF FWHM NEGATIVE AT TWO-THETA',F8.3,
     }    'FOR PHASE NO. ',I4)
      END IF
      IF (NPROF.EQ.8) THEN
       HALFL(NN) = AH2*TANTH+BH2*SQRT(1.+TANTH*TANTH)
       BB = HALFG(NN)**5.+2.69269*HALFG(NN)**4.*HALFL(NN)+
     1 2.42843*HALFG(NN)**3.*HALFL(NN)**2.+
     2 4.47163*HALFG(NN)**2.*HALFL(NN)**3. +
     3 0.07842*HALFG(NN)*HALFL(NN)**4. + HALFL(NN)**5.
      IF(BB.GT.0.0) BB=BB**0.2
      IF(BB.LT.0.0)BB=STEP/4.
       TLR = HALFL(NN)/BB
       GAM(NN) = 1.36603*TLR-0.47719*TLR*TLR+0.11116*TLR**3.
      ELSE
       BB = HALFG(NN)
      END IF
C      IF(LEGVAR(BB).EQ.-1)BB=STEP/4.
      TL=BB
      REFS(NN,1)=BB
      BB=BB*BB
C-----VERT=.TRUE. IF ASYMMETRY CORRECTION IS TO BE CALCULATED
      VERT=.FALSE.
      IF(REFS(NN,2).LE.RLIM)VERT=.TRUE.
C-----CALCULATION OF COS(H.X),SIN(H.X) AND TEMP. FACTOR FOR EACH ATOM
    3 DO 8 I=1,N
      SNXI=0.
      SAI=0.
      SBI=0.
      DO 9 J=1,11
    9 XI(J)=XL(I+IOF,J)
      DO 10 IR=1,IRL
      DO 301 J=1,3
      IV=IVEC(IPH,IR)/32768/32**(3-J)
      IV=MOD(IV,32)
      SM(J,1)=IV/9-1
      SM(J,2)=MOD(IV/3,3)-1
      SM(J,3)=MOD(IV,3)-1
  301 T(J)=FLOAT(MOD(IVEC(IPH,IR)/32**(3-J),32)-16)/12.0
      X=0.
      DO 6 II=1,3
      YY=0.
      X=T(II)*HNN(II)+X
      DO 7 J=1,3
    7 YY=SM(J,II)*HNN(J)+YY
    6 H(II)=YY
      TR=X
      ARG=TR
      DO 11 J=1,3
   11 ARG=H(J)*XI(J)+ARG
      ARG=6.28318530718*ARG
       ARG2=H(1)*H(1)*XI(6)+H(2)*H(2)*XI(7)+
     1H(3)*H(3)*XI(8)+2.*H(1)*H(2)*XI(9)+2.*
     2 H(1)*H(3)*XI(10)+2.*H(2)*H(3)*XI(11)
      EXPARG=EXP(-ARG2)
      COSA=COS(ARG)*EXPARG
      SINA=SIN(ARG)*EXPARG
      SAI=SAI+COSA
      IF(ICENT.EQ.1)SBI=SINA+SBI
      DO 14 JJ=1,3
      SUMAX(I,JJ)=SUMAX(I,JJ)+H(JJ)*SINA
  14  IF(ICENT.EQ.1)SUMBX(I,JJ)=SUMBX(I,JJ)+H(JJ)*COSA
      SUMAX(I,4)=SUMAX(I,4)+H(1)*H(1)*COSA
      SUMAX(I,5)=SUMAX(I,5)+H(2)*H(2)*COSA
      SUMAX(I,6)=SUMAX(I,6)+H(3)*H(3)*COSA
      SUMAX(I,7)=SUMAX(I,7)+H(1)*H(2)*COSA
      SUMAX(I,8)=SUMAX(I,8)+H(1)*H(3)*COSA
      SUMAX(I,9)=SUMAX(I,9)+H(2)*H(3)*COSA
      IF(ICENT.NE.1)GOTO 10
      SUMBX(I,4)=SUMBX(I,4)+H(1)*H(1)*SINA
      SUMBX(I,5)=SUMBX(I,5)+H(2)*H(2)*SINA
      SUMBX(I,6)=SUMBX(I,6)+H(3)*H(3)*SINA
      SUMBX(I,7)=SUMBX(I,7)+H(1)*H(2)*SINA
      SUMBX(I,8)=SUMBX(I,8)+H(1)*H(3)*SINA
      SUMBX(I,9)=SUMBX(I,9)+H(2)*H(3)*SINA
   10 CONTINUE
      TEMP(I)=EXP(-XL(I+IOF,4)*SSNN)
      SA(I)=SAI
      SB(I)=SBI
      NI=PTR(I+IOF)
      BNI=DFPP(NI)
      FFX=DFP(NI)
      AC(10,NI)=0.
      DO 302 II=1,9,2
 302  FFX=FFX+AC(II,NI)*EXP(-AC(II+1,NI)*SSNN)
      SNEXI=FFX*XL(I+IOF,5)*TEMP(I)
      SNXI=BNI*XL(I+IOF,5)*TEMP(I)
C-----CALCULATE A AND B OF F
      AV=SNEXI*SAI+AV
      BV=SNEXI*SBI+BV
      SNEX(I)=2.*SNEXI*TAV*RATIO(ICX)
      SNX(I)=2.*SNXI*TAV*RATIO(ICX)
      CV=CV+SNXI*SAI
      DV=DV+SNXI*SBI
    8 CONTINUE
C-----CALCULATE THE PHASE IN RADIANS
C
C  MODIF LE BAIL: POWDER, NOT CRYSTAL !!!
C
C
      FNN=CV*CV+AV*AV+DV*DV+BV*BV
C     FNN = AV*AV+BV*BV+CV*CV+DV*DV+2.*(BV*CV-AV*DV) 
      PHASEN(NN)=0.
      IF (FNN.NE.0.) PHASEN(NN)=ASIN((BV+CV)/SQRT(FNN))
      IF ((AV-DV).LT.0.)PHASEN(NN)=3.14159265-PHASEN(NN)
      IF (PHASEN(NN).LT.0.) PHASEN(NN)=PHASEN(NN)+6.28318530
      FNN=RATIO(ICX)*FNN*TAV
  120 FF(NN)=FNN
      IF(MAXS.EQ.0)RETURN
C-----CALCULATE DERIVATIVES
      DO 17 I=1,N
      SNEXI=SNEX(I)
      SNXI=SNX(I)
      SAI=SA(I)
      SBI=SB(I)
      DO 22 J=1,11
      K=LP(I+IOF,J)
      IF(K.EQ.0) GOTO22
      IF(J.GT.5) GOTO 221
      IF(J.GT.3)GOTO 29
      SUMA=SUMAX(I,J)
      SUMB=SUMBX(I,J)
      DER=-((AV*SUMA-BV*SUMB)*SNEXI+(CV*SUMA-DV*SUMB)*SNXI)*6.2831853071
      GOTO 26
   29 IF(J.GT.4)GOTO 31
      DER=-((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)*SSNN
      GOTO 26
   31 DER=((SAI*AV+SBI*BV)*SNEXI+(SAI*CV+SBI*DV)*SNXI)/XL(I+IOF,5)
      GOTO 26
  221 SUMA=SUMAX(I,J-2)
      SUMB=SUMBX(I,J-2)
      DER=-((AV*SUMA+BV*SUMB)*SNEXI+(CV*SUMA+DV*SUMB)*SNXI)
      IF(J.GE.9)DER=2.*DER
   26 DERIV(K) = SIGN(1.,A(I+IOF,J))*DER+DERIV(K)
   22 CONTINUE
   17 CONTINUE
C-----CALCULATE DERIVATIVES
C
C DERIVATES OF THE MARCH'S AND PECHARSKII'S MODEL FOR PREFERED
C ORIENTATION INCLUDED
C
      K=LPAR(IPH,12)
      IF (NORI.EQ.0) THEN
      IF (K.NE.0) DERIV(K) = DERIV(K)+PAKNN*(1.-B2)*PREXP
     *                         *FNN/PRECOR
C      IF (K.NE.0) DERIV(K) = DERIV(K)+APAR(IPH,12)*PAKNN*(1.-B2)*PREXP
C     *                         *FNN/PRECOR
      ELSE IF (NORI.EQ.1) THEN
      IF (K.NE.0) DERIV(K) = DERIV(K)-1.5*PREDEV*FNN/PAKNN
C      IF (K.NE.0) DERIV(K) = DERIV(K)-1.5*PREDEV*FNN/PAKNN*APAR(IPH,12)
      ELSE
      STOP 'NOT YET AVAILABLE'
      ENDIF
      K=LPAR(IPH,13)
      IF(K.NE.0)DERIV(K)=DERIV(K)+(1.-PREXP)*FNN/PRECOR
C      IF(K.NE.0)DERIV(K)=DERIV(K)+APAR(IPH,13)*(1.-PREXP)*FNN/PRECOR
      K=LPAR(IPH,2)
      IF(K.NE.0)DERIV(K)=DERIV(K)-2.*SSNN*FNN
C      IF(K.NE.0)DERIV(K)=DERIV(K)-2.*APAR(IPH,2)*SSNN*FNN
      K=LPAR(IPH,1)
      IF(K.NE.0)DERIV(K)=DERIV(K)+FNN/PAR(IPH,1)
C      IF(K.NE.0)DERIV(K)=DERIV(K)+APAR(IPH,1)*FNN/PAR(IPH,1)
C      DO 15 J=8,9
      K=LGLB(8)
      IF(K.NE.0.AND.(NPROF.EQ.6.OR.NPROF.EQ.7))DERIV(K)=DERIV(K)+FNN
C                                  DERIV(K)=DERIV(K)+FNN*APAR(IPH,8) 
      K=LGLB(9)
      IF(K.NE.0.AND.NPROF.EQ.5) DERIV(K)=DERIV(K)+FNN
C                               DERIV(K)=DERIV(K)+FNN*APAR(IPH,9) 
C   15 CONTINUE
      SINTH=FNN*PI*SLABDA/(SQRT(SINTH*COSTH)*BB)
      SS=FNN/TL
      X=TANTH*TANTH
      IF (NPROF.EQ.8) GO TO 9211
      DO 78 J=3,5
      K=LPAR(IPH,J)
      IF(K.EQ.0)GOTO 78
      DERIV(K)=X*SS+DERIV(K)
C      DERIV(K)=X*APAR(IPH,J)*SS+DERIV(K)
   78 X=X/TANTH
9211  CONTINUE
      IF (NPROF.EQ.8) THEN
      TL = REFS(NN,1)
      TLG = HALFG(NN)
      TLL = HALFL(NN)
      DHDHG = 0.2/TL**4.*(5.*TLG**4.+10.77076*TLG**3.*TLL+
     }   7.28529*TLG*TLG*TLL*TLL+8.94326*TLG*TLL**3.
     } + 0.07842*TLL**4.)
      DHDHL = 0.2/TL**4.*(2.69269*TLG**4.+ 4.85686*TLG**3.*TLL
     } +13.41489*TLG*TLG*TLL*TLL + 0.31368*TLG*TLL**3.+5.*TLL**4.)
      DO 9078 J=3,5
      K=LPAR(IPH,J)
      IF(K.EQ.0)GOTO 9078
      DERIV(K)=DHDHG*X*SS+DERIV(K)
C      DERIV(K)=DHDHG*APAR(IPH,J)*X*SS+DERIV(K)
 9078 X=X/TANTH
      K = LPAR(IPH,15)
      IF (K.EQ.0) GO TO 9213
      DERIV(K) = 2.*FNN*DHDHL*TANTH + DERIV(K)
C      DERIV(K) = 2.*APAR(IPH,15)*FNN*DHDHL*TANTH + DERIV(K)
 9213 CONTINUE
      K = LPAR(IPH,16)
      IF (K.EQ.0) GO TO 9214
      DERIV(K) = 2.*FNN*DHDHL/SQRT(COSTH) + DERIV(K)
C      DERIV(K) = 2.*APAR(IPH,16)*FNN*DHDHL/SQRT(COSTH) + DERIV(K)
 9214 CONTINUE
      END IF
      K = LPAR(IPH,17)
      IF(K.NE.0.AND.(NPROF.EQ.6.OR.NPROF.EQ.7)) THEN
      DERIV(K)=DERIV(K)+ FNN
C      DERIV(K)=DERIV(K)+ APAR(IPH,17)*FNN
      END IF
C
C  LINEAR VARIATION OF ETA WITH 2THETA (MODIF.)
C
      IF(NPROF.EQ.6) THEN
      K=LPAR(IPH,15)
      IF(K.NE.0) DERIV(K)=DERIV(K)+FNN*REFS(NN,2)
      END IF
C
C
C
      K=LGLB(1)
      IF(K.NE.0)DERIV(K)=2.*FNN/BB+DERIV(K)
C               DERIV(K)=2.*APAR(IPH,1)*FNN/BB+DERIV(K)
      K=LGLB(10)
      IF (K.NE.0) DERIV(K) = DERIV(K)+2.*FNN/BB*SQRT(COSTH)
C                 DERIV(K) = DERIV(K)+2.*APAR(IPH,10)*FNN/BB*SQRT(COSTH)
      K=LGLB(11)
      IF (K.NE.0) DERIV(K) = DERIV(K)+2.*FNN/BB*SIN(REFS(NN,2)/57.2958)
C     DERIV(K) = DERIV(K)+2.*APAR(IPH,11)*FNN/BB*SIN(REFS(NN,2)/57.2958)
      K = LGLB(1)
      IF (K.NE.0)DERIV(K) = AGLB(1)*2.*FNN/BB+DERIV(K)
C                DERIV(K) = APAR(IPH,1)*AGLB(1)*2.*FNN/BB+DERIV(K)
      DO 79 J=1,6
      K=LPAR(IPH,J+5)
      IF(K.EQ.0)GOTO 79
      IF(J.LT.4)X=HNN(J)*HNN(J)
      IF(J.EQ.4)X=HNN(2)*HNN(3)
      IF(J.EQ.5)X=HNN(1)*HNN(3)
      IF(J.EQ.6)X=HNN(1)*HNN(2)
      DERIV(K)=X*SINTH+DERIV(K)
   79 CONTINUE
      K=LPAR(IPH,14)
      IF((K.NE.0).AND.VERT)DERIV(K)=-FNN/TANTH+DERIV(K)
C-----STORE DERIVATIVES FOR LIMO REFLECTIONS AT A TIME
      DO 80 I=1,MAXS
   80 DERSTO(NM,I)=DERIV(I)
   48 RETURN
      END
      SUBROUTINE EXPUT
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      REAL LAMDA
      INTEGER PTR
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1,ISPACE*1,IDOT*1,ISTAR*1,IPLUS*1,IMINUS*1
     *,IBAR*1
      CHARACTER TITLE*70,PHSNM(8)*70
      CHARACTER*1 IOUT(150)
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER*4 NAM(16)
      COMMON/COEFC/NAM
C&    COMMON/CONSTR/CONA(2,16,8),ICON(2,16,8),JCON(2,16,8),LCONI(2,16,8)
C&   *,LCONJ(2,16,8),DF(2,16),LN(2,16)
      COMMON/DATAX/Y(IDSZ),VAR(IDSZ),YC(IDSZ),KR(IDSZ),BK(IDSZ)
     *,IWW(IDSZ),NPTS
      COMMON/REFLS/IREFS(IRS),REFS(IRS,3),FF(IRS),PHASEN(IRS),IC(8)
     } ,HALFL(IRS),HALFG(IRS),GAM(IRS)
      COMMON/PRFX/DELT,TL,GAM1,GAM2,PRFDER
      DIMENSION DEL(10),KI(10)
      DIMENSION RJAC(MSZ,MSZ)
      EQUIVALENCE (RJAC(1,1),KR(1))
      DIMENSION LABEL(12),KS(50)
      LOGICAL VERT
      DATA ISPACE,IDOT,ISTAR,IPLUS,IMINUS,IBAR/' ','.','*','+','0','-'/
      IF(NXT.EQ.0) NPROF=NPROF-1
      RAD = 45./ATAN(1.)
      ZER=GLB(1)
      IF(IPL.NE.0)READ(5,19,END=10000)ISCALE,IDIF
   19 FORMAT(BZ,2I8)
10000 IF(IPL2.NE.0)READ(5,17,END=10001)IFY,IFYC,IFM,IFD,IFB,EXPAND
10001 IF(JOBTYP.GT.2)IFY=0
      IF(JOBTYP.GT.2)IFD=0
   17 FORMAT(BZ,5I1,3X,F8.0)
      IF(NXT.NE.0.AND.JOBTYP.LT.3)CALL REWRIT(ISCALE,IDIF,IFY,IFYC
     *,IFM,IFD,IFB,EXPAND)
      IF(JOBTYP.GT.2)GOTO 37
      WRITE(6,10)
   10 FORMAT(42H0AVERAGE INTENSITY DIFFERENCE FOR PATTERN,,/,
     137H0GIVEN FOR BLOCKS OF 20 OBSERVATIONS.)
      DO 15 I=1,NPTS,200
      DO 14 J=1,10
      J20=20*(J-1)
      DEL(J)=0
      DO 13 K=1,20
      J20IK=J20+I+K-1
   13 DEL(J)=DEL(J)+Y(J20IK)-BK(J20IK)-YC(J20IK)
      KI(J)=J+I/20
      DEL(J)=DEL(J)/20.
      IF(KI(J)*20.GE.NPTS)GOTO 15
   14 CONTINUE
      J=10
   15 WRITE(6,20)(KI(JJ),DEL(JJ),JJ=1,J)
   20 FORMAT(1H0,6X,10(I4,G8.1))
      IF(MAT.EQ.0)GOTO 37
      WRITE(6,7)
      IA=1
      LIM=19
   38 LIM=MIN0(MAXS,LIM)
      WRITE(6,8)(I,I=IA,LIM)
      DO 39 I=1,MAXS
      L=0
      X=RJAC(I,I)
      DO 40 J=IA,LIM
      L=L+1
      YY=RJAC(J,J)*X
   40 KS(L)=100.*RJAC(I,J)/(SQRT(ABS(YY))*SIGN(1.,YY))+0.5
   39 WRITE(6,12)I,(KS(J),J=1,L)
      IF(LIM.GE.MAXS)GOTO 37
      IA=LIM+1
      LIM=LIM+19
      GOTO 38
    7 FORMAT(20H0CORRELATION MATRIX=)
    8 FORMAT(5H0    ,19I6)
   12 FORMAT(I5,19I6)
   37 DO 47 I=1,NPTS
      YC(I)=YC(I)+BK(I)
   47 IF(JOBTYP.GT.2)Y(I)=YC(I)
      IF(IPC.EQ.0)GOTO 36
      ICZ=0
      DO 4300 IIPHAS=1,NPHASE
        ICZ = ICZ+IC(IIPHAS)
4300  CONTINUE
      IITTT=1
      DO 400 K=1,NPHASE
C     GAM1=PAR(K,17)
      WRITE (6,4289) K,PHSNM(K)
4289  FORMAT (/'1PHASE NO. = ',I3,5X,'PHASE NAME ',A70)
      T2OBS=0.
      TDOBS=0.
      TFOO=0.
      TDFOC=0.
      IXX=0
      IXXX=0
      DO 481 IX=1,ICZ
      IF(K.NE.IREFS(IX)/256/256/256/8)GOTO 481
      SHIFT = GLB(10) * COS(REFS(IX,2)/2./57.2958)
     }      + GLB(11) * SIN(REFS(IX,2)/57.2958)
      IXX=IXX+1
      DO 485 J=1,NEXCRG
      IF((REFS(IX,2)+SHIFT+ZER).GE.(ALOW(J)-WDT*REFS(IX,1))
     }                      .AND.
     }(REFS(IX,2)+SHIFT+ZER).LE.(AHIGH(J)+WDT*REFS(IX,1))) GOTO 481
  485 CONTINUE
      IRL=MOD(IREFS(IX),256)-128
      IRK=MOD(IREFS(IX)/256,256)-128
      IRH=MOD(IREFS(IX)/256/256,256)-128
      IRC=MOD(IREFS(IX)/256/256/256,8)
      RMIN=REFS(IX,2)+ZER-WDT*REFS(IX,1)
      RMAX=REFS(IX,2)+ZER+WDT*REFS(IX,1)
      MIN=(RMIN-THMIN)/STEP+1.5
      MAX=(RMAX-THMIN)/STEP+1.5
      MIN=MAX0(MIN,1)
      MIN=MIN0(MIN,NPTS)
      MAX=MIN0(MAX,NPTS)
C     PATCH TO CALCULATE R-BRAGG
      TL=REFS(IX,1)
      VERT=REFS(IX,2).LE.RLIM
      IF(NPROF+1.EQ.6) GAM1=PAR(K,17)+PAR(K,15)*REFS(IX,2)
      IF(NPROF.EQ.7) THEN
      GAM1 = GAM(IX)
      TLG = HALFG(IX)
      TLL = HALFL(IX)
      END IF
      BB=TL*TL
      TIOBS =0.
      TIC=0.
      PHRD = PHASEN(IX)
      FFFC = SQRT(FF(IX))
      IF (JOBTYP.GT.2) THEN
        TIC = FF(IX)*REFS(IX,3)*PAR(K,1)
        TFOO = 1.
        T2OBS = 1.
        TDFOC = 0.0
        TDOBS = 0.0
        TIOBS = TIC
        GOTO 5327
      ENDIF
      FF(IX)=FF(IX)*REFS(IX,3)*PAR(K,1)
      DO 410 IS=MIN,MAX
      TH=THMIN+FLOAT(IS-1)*STEP
      IF(NEXCRG.GT.0) THEN
       DO 1450 IEXC=1,NEXCRG
       IF (TH.GE.ALOW(IEXC).AND.TH.LE.AHIGH(IEXC)) GO TO 410
1450   CONTINUE
      END IF
      TH2 = 0.5*TH/RAD
      DELTA=TH-REFS(IX,2)-ZER-SHIFT
      DELT=DELTA*DELTA
C     NEXT LINE IS NECESSARY FOR 2 PHASES WITH VERY DIFFERENT FWHM.
      IF (DELT/BB.GT.WDT*WDT) GO TO 410
      IF(.NOT.VERT)GOTO 4
      YX=DELT*SIGN(1.,DELTA)
      Z=1.-PAR(K,14)*YX/TAN(TH2)
      IF(Z.LE.0.)Z=.0001
      GOTO 5
    4 Z=1.
    5 OMEGA= Z*PROFIL(NPROF+1,DELT/BB)
      TIC   = TIC + OMEGA
      TIOBS = TIOBS + OMEGA*(Y(IS)-BK(IS))/AMAX1((YC(IS)-BK(IS)),1.)
410   CONTINUE
      TIC = TIC*FF(IX)*STEP/TL
      TIOBS = TIOBS*FF(IX)*STEP/TL
C
C MODIF
C
      IF (JOBTYP.GT.2) GOTO 323
      IF (TIOBS.LT.0.) TIOBS = 0.  
      FFFO = SQRT(TIOBS/TIC)*FFFC
      IF (FFFC.LT.0..OR.TIOBS.LE.0.00001) THEN
        SFFF = 0.0
      ELSE
        SFFF = FFFC/2.0/SQRT(TIOBS/PAR(K,1)/(STEP/TL))
      ENDIF
      IF (IRC.EQ.2) GOTO 323
      DFFF = FFFO-FFFC
      IF (JFOU.EQ.1) WRITE(9,322)IRH,IRK,IRL,FFFC,PHRD,FFFO,SFFF
 322  FORMAT(3I5,4F10.4)
 323  T2OBS = T2OBS+TIOBS
      DELCS = TIOBS-TIC
      TDOBS = TDOBS+ABS(DELCS)
      TFOO = TFOO+FFFO
      TDFOC = TDFOC+ABS(FFFO-FFFC)
5327  HW = REFS(IX,1)
      IF (JLKH.EQ.1) WRITE(10,327) IRH,IRK,IRL,IRC,REFS(IX,2),HW,TIOBS
     *                            ,TIC,DELCS
 327  FORMAT(4I4,2F10.3,3F12.1)
      IF (IRC.EQ.2) GOTO 481
      IXXX = IXXX+1
C
C END OF MODIF
C      
      IF (NPROF.EQ.7) GO TO 9222
      IF(MOD(IXXX-1,60).EQ.0)WRITE(6,482)
      HW=REFS(IX,1)
      WRITE(6,470)IXXX,IRC,IRH,IRK,IRL,HW,REFS(IX,2),TIC
     1,TIOBS
      GO TO 481
9222  CONTINUE
      IF(MOD(IXX-1,60).EQ.0)WRITE(6,9482)
      HW=REFS(IX,1)
      WRITE(6,9470)IXX,IRC,IRH,IRK,IRL,HW,REFS(IX,2),TIC
     1,TIOBS,TLG,TLL,GAM1
  481 CONTINUE
      IF (JLKH.EQ.1) WRITE(10,325)
 325  FORMAT('        ')
 482  FORMAT(32H0NO.  CODE    H   K   L   HW     ,
     *16HPOSN      ICALC ,4X,5HIOBS /)
 470  FORMAT(1X,2I4,3X,3I4,2F8.3,2F10.0)
      TDOBS=100.*TDOBS/T2OBS
      TDFOC = 100.*TDFOC/TFOO
      WRITE(6,483)TDOBS,TDFOC
      WRITE(8,483)TDOBS,TDFOC
      IF (JCIL.EQ.1) WRITE(2,1483) TDOBS,TDFOC
1483  FORMAT(2F8.2)
  483 FORMAT(26H0 DERIVED BRAGG R-FACTOR=  ,F8.2/1X,'RF-FACTOR=',F8.2)
9482  FORMAT(32H0NO.  CODE    H   K   L   HW     ,
     *16HPOSN      ICALC ,4X,5HIOBS ,6X,' HG      HL      ETA   ')
9470  FORMAT(1X,2I4,3X,3I4,2F8.3,2F10.0,3F8.3)
 400  CONTINUE
  36  IF(JCIL.EQ.1.AND.IPC.EQ.0) THEN
	DO IP1=1,NPHASE
		WRITE(2,1483) TDOBS,TDFOC
	END DO
      ENDIF	
      IF(IOT.EQ.0)GOTO 30
      NP=NPTS/240
      DO 31 I=1,NPTS
   31 BK(I)=THMIN+FLOAT(I-1)*STEP
      WRITE(6,101)(((BK(240*N-300+60*I+J),Y(240*N-300+60*I+J),YC(
     }240*N-300+60*I+J),VAR(240*N-300+60*I+J),I=1,4),J=1,60),N=1,NP)
 101  FORMAT((2H1 ,4(6H2THETA,3X,4HYOBS,4X,5HYCALC,1X,8HVARIANCE,1X),/,
     } 60(4(1X,F7.3,3F8.0),/)))
      NPTS2=NPTS-NP*240
      IF(NPTS2.EQ.0)GOTO 30
      NCOL=NPTS2/60
      WRITE(6,103)
 103  FORMAT(2H1 ,4(6H2THETA,3X,4HYOBS,4X,5HYCALC,1X,8HVARIANCE,1X))
      NLINES=NPTS2-NCOL*60
      IF(NLINES.EQ.0)GOTO 33
      NCOL1=NCOL+1
      NP=240*NP-60
      DO 34 J=1,NLINES
 34   WRITE(6,102)(BK(NP+60*I+J),Y(NP+60*I+J),YC(NP+60*I+J),
     } VAR(NP+60*I+J),I=1,NCOL1)
 102  FORMAT(4(1X,F7.3,3F8.0))
      NP=NP+NLINES
      NLINES=60-NLINES
   33 DO 35 J=1,NLINES
 35   WRITE(6,102)(BK(NP+60*I+J),Y(NP+60*I+J),YC(NP+60*I+J),
     } VAR(NP+60*I+J),I=1,NCOL)
 30   IF(IPL.EQ.0)GOTO 45
      DO210I=1,12
  210 LABEL(I)=10*I*ISCALE
      WRITE(6,100) TITLE,LABEL
  100 FORMAT(1H1,30X,A70//1X,12I10)
      DO11I=1,12
   11 LABEL(I)=-60*IDIF+10*I*IDIF
      WRITE(6,203) LABEL
  203 FORMAT(1H ,12I10)
      DO 60 I=1,NPTS
    1 DO 3 J=1,120
    3 IOUT(J)=ISPACE
      IOUT(1)=IDOT
      IOUT(61)=IDOT
      IOUT(120)=IDOT
  200 IY=INT(Y(I))/ISCALE+2
      IY=MAX0(MIN0(IY,120),2)
      IOUT(IY-1)=IBAR
      IOUT(IY)=IPLUS
      IF(IY.LE.119)IOUT(IY+1)=IBAR
      IY=INT(YC(I))/ISCALE+2
      IY=MAX0(MIN0(IY,120),2)
      IOUT(IY)=IMINUS
      IY=INT(Y(I)-YC(I))/IDIF+61
      IY=MAX0(MIN0(IY,120),2)
      IOUT(IY)=ISTAR
      IF(MOD(I-1,10).NE.0) GOTO 55
       TLABEL=THMIN+STEP*FLOAT(I-1)
      WRITE(6,104)(IOUT(J),J=1,113),TLABEL,IOUT(120)
  104 FORMAT(1X,113A1,F6.2,A1)
       GO TO 60
   55   WRITE(6,201) (IOUT(J),J=1,120)
  201 FORMAT(1X,120A1)
   60 CONTINUE
   45 IF(JOBTYP.LT.3)GOTO 72
C      REWIND 4
C      WRITE(4,70)THMIN,STEP,THMAX
C   70 FORMAT(3F8.4)
C      WRITE(4,71)(YC(I),I=1,NPTS)
   71 FORMAT(8(F7.0,1X))
   72 CONTINUE
C   72 IF(IPL2.NE.0)CALL CALPLT(IFY,IFYC,IFM,IFD,IFB,EXPAND,ZER)
      IF (IPL2.NE.0) THEN
        IVERS=8
        WRITE(1,2001) TITLE      
        WRITE(1,2002) IFY,IFYC,IFM,IFD,EXPAND,ZER      
        WRITE(1,2003) THMAX,THMIN,STEP,IVERS     
        WRITE(1,2004) NPHASE,NPTS     
        WRITE(1,2005) (IC(I),I=1,NPHASE)      
        WRITE(1,71) (Y(J),J=1,NPTS)      
        WRITE(1,71) (YC(J),J=1,NPTS)
        WRITE(1,2006) (IREFS(J),J=1,ICZ)      
        WRITE(1,2007) (REFS(J,2),J=1,ICZ)
        WRITE(1,2008) NEXCRG
        WRITE(1,2009) (ALOW(J),AHIGH(J),J=1,NEXCRG)
      END IF
2001  FORMAT(A70)      
2002  FORMAT(4I1,2F9.4)      
2003  FORMAT(3F8.3,I8)      
2004  FORMAT(I3,I5)      
2005  FORMAT(8I5)      
2006  FORMAT(8I10)      
2007  FORMAT(10F8.3)      
2008  FORMAT(I8)
2009  FORMAT(2F8.2)
      RETURN
      END
      SUBROUTINE REWRIT(ISCALE,IDIF,IFY,IFYC,IFM,IFD,IFB,EXPAND)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      REAL LAMDA
      INTEGER PTR
      COMMON/DC/SAVE(8,6),NSAVE
      COMMON/G1/THMIN,STEP,THMAX,U,V,W,LAMDA(2),TMV,CTHM,RKK,RLIM,
     *          BKPOS,WDT,ULOR,VLOR
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1
      CHARACTER TITLE*70,PHSNM(8)*70
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(10,16),POSI(30),SCAT(30),DFP(16),DFPP(16)
      CHARACTER*4 NAM(16)
      COMMON/COEFC/NAM
C&    COMMON/CONSTR/CONA(2,16,8),ICON(2,16,8),JCON(2,16,8),LCONI(2,16,8)
C&   *,LCONJ(2,16,8),DF(2,16),LN(2,16)
      REWIND 5
      WRITE(5,1)TITLE
   1  FORMAT(A70)
      JOBTYP=JOBTYP-1
      NPROF=NPROF-1
      WRITE(5,2)JOBTYP,NPROF,NPHASE,NBCKGD,NEXCRG,NSCAT,NORI,IRF,IWGT
   2  FORMAT(9I4)
      WRITE(5,14)IOT,IPL,IPC,MAT,NXT,LST1,LST2,LST3,IPL1,IPL2,INSTR,
     *           JCIL,JSY,JLKH,JFOU
  14  FORMAT(15I1)
      WRITE(5,23)LAMDA,RATIO(2),BKPOS,WDT,CTHM,TMV,RLIM,RKK
  23  FORMAT(9F8.4)
      WRITE(5,30)MCYCLE,EPS,RELAX,THMIN,STEP,THMAX
  30  FORMAT(1I4,5F4.2,3F8.3)
      IF(NBCKGD.LT.2)GOTO 120
      WRITE(5,34)(POS(I),BCK(I),I=1,NBCKGD)
  34  FORMAT(2F8.2)
 120  IF(NEXCRG.LE.0)GOTO 122
      WRITE(5,34)(ALOW(I),AHIGH(I),I=1,NEXCRG)
 122  IF(NSCAT.LE.0)GOTO 124
      DO 125 I=1,NSCAT
      WRITE(5,38)NAM(I),DFP(I),DFPP(I)
 38   FORMAT(A4,2F8.4)
 126  IF(JOBTYP.EQ.0)WRITE(5,39)(AC(J,I),J=1,9)
 39   FORMAT(9F8.5)
 125  CONTINUE
  124 CONTINUE
      WRITE(5,43)MAXS
   43 FORMAT(I8)
      N=0
      DO 4310 IIPHAS=1,NPHASE
4310  N=N+NATOM(IIPHAS)
      DO 84 I=1,N
      DO 84 J=1,11
  84  A(I,J)=SIGN(1.,A(I,J))*(FLOAT(10*LP(I,J))+ABS(A(I,J)))
      DO 87 I=1,NPHASE
      DO 88 J=1,6
   88 PAR(I,J+5)=SAVE(I,J)
      DO 87 J=1,17
  87  APAR(I,J)=SIGN(1.,APAR(I,J))*(FLOAT(10*LPAR(I,J))+ABS(APAR(I,J)))
      DO 89 J=1,11
  89  AGLB(J)=SIGN(1.,AGLB(J))*(FLOAT(10*LGLB(J))+ABS(AGLB(J)))
      IF(NPROF.EQ.7) THEN
       GLB(8) = 0.0
       AGLB(8) = 0.0
      END IF
      WRITE(5,45)GLB(1),AGLB(1),(GLB(J),AGLB(J),J=8,11)
   45 FORMAT(10F8.4)
      IF(NBCKGD.EQ.0)WRITE(5,46)(GLB(J),J=2,7),(AGLB(J),J=2,7)
   46 FORMAT(6G12.6,/,6F12.6)
 477  DO 81 K=1,NPHASE
      IOF=0
      IF(K.GT.1) THEN
       DO 4311 IIPHAS=2,K
4311   IOF = IOF + NATOM (IIPHAS-1)
      END IF
      WRITE(5,465)PHSNM(K)
  465 FORMAT(A70)
      WRITE(5,48)NATOM(K),NEQC(K),NINEQC(K),(PREF(K,I),I=1,3)
   48 FORMAT(3I4,3F4.2)
      N=NATOM(K)
      WRITE(5,460)(SYMB(K,I),I=1,20)
  460 FORMAT(20A1)
      WRITE(5,65)(ATEXT(I+IOF),NTYP(I+IOF),
     }(XL(I+IOF,J),J=1, 5),(A(I+IOF,J),J=1, 5),
     }(XL(I+IOF,J),J=6,11),(A(I+IOF,J),J=6,11),
     } I=1,N)
   65 FORMAT(2A4,8X,5F8.5,/,16X,5F8.2,/,6F8.5,/,6F8.2)
C     WRITE(5,50) PAR(K,1),PAR(K,17),(PAR(K,I),I=2,16)
      WRITE(5,50) PAR(K,1),PAR(K,17),PAR(K,2),
     }            APAR(K,1),APAR(K,17),APAR(K,2),
     } PAR(K,3),PAR(K, 4),PAR(K,5),PAR(K,15),PAR(K,16),
     } APAR(K,3),APAR(K, 4),APAR(K,5),APAR(K,15),APAR(K,16),
     } (PAR(K,I),I=6,11), (APAR(K,I),I=6,11),
     } PAR(K,12),PAR(K,13),PAR(K,14),
     } APAR(K,12),APAR(K,13),APAR(K,14)
   50 FORMAT(G8.3,F8.4,F8.4,32X,'SCALE  ETA  OVERALL B',/
     },3F8.2,/,
     }5F8.5,16X,'U V W X Y',/,5F8.2,/,
     }6F8.4,8X,'CELL PARAMETERS',/,6F8.2,/,
     } 3F8.5,32X,'PREF1 PREF2 ASYMMETRY',/,3F8.2)
C  50 FORMAT(G8.3,F8.4,F8.4,/,3F8.5,/,6F8.4,/,3F8.5,/,2F8.5)
C     WRITE(5,861)((A(I+IOF,J),J=1,11),I=1,N)
C 861 FORMAT(5F8.2,/,6F8.2)
C     WRITE(5,86) APAR(K,1),APAR(K,17),(APAR(K,I),I=2,16)
C  86 FORMAT(F8.2,F8.2,F8.2,/,3F8.2,/,6F8.2,/,3F8.2,/,2F8.2)
   81 CONTINUE
      IF(IPL.NE.0)WRITE(5,191)ISCALE,IDIF
  191 FORMAT(2I8)
      IF(IPL2.NE.0)WRITE(5,171)IFY,IFYC,IFM,IFD,IFB,EXPAND
      IF(IPL2.EQ.0)WRITE(5,171)  2,   1,  1,  1,0,0.95
  171 FORMAT(5I1,3X,F8.4)
  151 RETURN
      END
      SUBROUTINE OUTPTR(ICYCLE,ICONDI)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/DC/SAVE(8,6),NSAVE
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(30),AHIGH(30),POS(100),BCK(100),
     *NATOM(8),NEQC(8),NINEQC(8),PREF(8,3),NBCKGD,NEXCRG,NSCAT
      CHARACTER SYMB(8,20)*1
      CHARACTER TITLE*70,PHSNM(8)*70,TAF*4
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/G3/COND,IORD1,IORD2,TH,NUM
      COMMON/CNTRLS/JOBTYP,NPROF,NPHASE,IOT,IPL,IPC,MAT,NXT,LST1,LST2,
     *LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,NORI,JCIL,JSY,JLKH,JFOU,IRF,IWGT
      COMMON/FORMATO/INSTR,NUMOR,DATE(20),TXT1(20),TXT2(20),TXT3(20)
      COMMON/G2/S1,S2,S3,D1,D2,R1,R2,R3,DEVINC,YINV,DW
      COMMON/F1/SMM(MSZ,MSZ),V(MSZ)
      DIMENSION SY(20),SZ(20),DCSM(6,6),DCV(6)
      LOGICAL YES
      CHARACTER*10 ID(5)
      ID(1)='SKEWNESS='
      ID(2)='  ETA   ='
      ID(3)='PEARSON-M='
      TAF='L.S.'
      IF(IWGT.GT.0) TAF='M.L.'
      YES = (ICYCLE.EQ.MCYCLE).OR.(ICONDI.EQ.123)
      WRITE(6,1)ICYCLE
      IF (ICONDI.EQ.123) WRITE(6,2)
    2 FORMAT('  ******* CONVERGENCE REACHED AT THIS CYCLE *******')
      WRITE(7,111)ICYCLE
 111  FORMAT(//14H CYCLE NUMBER=,I4)
    1 FORMAT(1H1,120(1H+)//14H CYCLE NUMBER=,I4)
      DO 10 IP=1,NPHASE
      IOF=0
      IF(IP.GT.1) THEN
       DO 4340 IIPHAS=2,IP
4340   IOF = IOF + NATOM(IIPHAS-1)
      END IF
      MAXCON=NEQC(1)+NEQC(2)+NINEQC(1)+NINEQC(2)
      WRITE(6,3)IP,PHSNM(IP)
    3 FORMAT(7H0PHASE ,I2,2H@D ,A70,/' NEW PARAMETERS, SHIFTS, AND ',
     *'STANDARD DEVIATIONS='//5H ATOM,5X,1HX,6X,2HDX,5X,2HSX,6X,1HY,6X,
     *2HDY,5X,2HSY,6X,1HZ,6X,2HDZ,5X,2HSZ,6X,1HB,6X,2HDB,5X,2HSB,
     *6X,1HN,6X,2HDN,5X,2HSN)
      N=NATOM(IP)
      IF (YES) THEN
        WRITE(8,1001)N
        IF (JCIL.EQ.1)WRITE(2,5001)N
      ENDIF
 1001 FORMAT(1X,'NATOM=',I5)
 5001 FORMAT(I6)
      IF (YES) WRITE(8,1015)
 1015 FORMAT(1X,'NAME,X,SX,Y,SY,Z,SZ,B,SB,OCC,SOCC'/)
      DO  4 I=1,N
      DO  5 J=1,5
      KM=LP(I+IOF,J)
      IF(KM.NE.0)GOTO  6
      SY(J)=0.
      SZ(J)=0.
      GOTO  5
    6 SZ(J)=SQRT(ABS(SMM(KM,KM)))
      SY(J)=V(KM)*A(I+IOF,J)*RELAX(1)
      XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
    5 CONTINUE
      IF (YES)WRITE(8,1000)ATEXT(I+IOF),(XL(I+IOF,J),SZ(J),J=1,5)
      IF ((YES).AND.JCIL.EQ.1) WRITE(2,1000) ATEXT(I+IOF),(XL(I+IOF,J)
     *                        ,SZ(J),J=1,5)
    4 WRITE(6,100)ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=1,5)
 1000 FORMAT(1X,A4,1X,3(2(F7.4,1X)),2F5.2,2(1X,F6.3))
  100 FORMAT(1X,A4,2X,5(3F7.4,1X))
      WRITE(6,101)
  101 FORMAT(5H0ATOM,7X,3HB11,6X,4HDB11,6X,4HSB11,7X,3HB22,6X,4HDB22,
     }6X,4HSB22,7X,3HB33,6X,4HDB33,6X,4HSB33,/,12X,3HB12,6X,4HDB12,6X,
     }4HSB12,7X,3HB13,6X,4HDB13,6X,4HSB13,7X,3HB23,6X,4HDB23,6X,4HSB23)
      DO  7 I=1,N
      DO  8 J=6,11
      KM=LP(I+IOF,J)
      IF(KM.NE.0)GOTO  9
      SY(J)=0.
      SZ(J)=0.
      GOTO  8
    9 SZ(J)=SQRT(ABS(SMM(KM,KM)))
      SY(J)=V(KM)*A(I+IOF,J)*RELAX(2)
      XL(I+IOF,J)=XL(I+IOF,J)+SY(J)
    8 CONTINUE
    7 WRITE(6,102)ATEXT(I+IOF),(XL(I+IOF,J),SY(J),SZ(J),J=6,11)
  102 FORMAT(1X,A4,9F10.6,/,5X,9F10.6)
      DO 17 J=1,17
      KM=LPAR(IP,J)
      IF(KM.NE.0)GOTO 18
      SY(J)=0.
      SZ(J)=0.
      GOTO 17
   18 SZ(J)=SQRT(ABS(SMM(KM,KM)))
      SY(J)=V(KM)*APAR(IP,J)*RELAX(3)
      PAR(IP,J)=PAR(IP,J)+SY(J)
   17 CONTINUE
      CALL DIRECT(DCSM,DCV,IP,N)
      DO 30 I=1,6
      SY(I+5)=DCV(I)-SAVE(IP,I)
   30 SAVE(IP,I)=DCV(I)
      WRITE(6,103) PAR(IP,1),SY(1),SZ(1),
     }PAR(IP,17),SY(17),SZ(17),
     }(PAR(IP,I),SY(I),SZ(I),I=2,5),
     *(DCV(I),SY(I+5),DCSM(I,I),I=1,6),(PAR(IP,I),SY(I),SZ(I),
     *I=12,16)
      IF (YES) WRITE(8,1016)
 1016 FORMAT('   CELL PARAMETERS')
      IF (YES) THEN
        WRITE(8,1002) (DCV(I),DCSM(I,I),I=1,6)
        IF (JCIL.EQ.1)WRITE(2,1002) (DCV(I),DCSM(I,I),I=1,6)
      ENDIF
 1002 FORMAT((F10.5,1X,F10.5))
      IF (YES) THEN
        WRITE(8,1017) PAR(IP,1),SZ(1)
     *               ,PAR(IP,17),SZ(17)
     *               ,(PAR(IP,I),SZ(I),I=2,5)
     *               ,(PAR(IP,I),SZ(I),I=12,16)
        IF (JCIL.EQ.1) WRITE(2,5017) PAR(IP,1),SZ(1)
     *               ,PAR(IP,17),SZ(17)
     *               ,(PAR(IP,I),SZ(I),I=2,5)
     *               ,(PAR(IP,I),SZ(I),I=12,16)
      ENDIF
  103 FORMAT('0OVERALL SCALE FACTOR=',3G9.3,/,
     *'0ETA(PSEUDO-VOIGT) M (PEARSON VII) = ',3F8.5,/,
     *'0OVERALL TEMP. FACTOR=',3F9.4,/,
     *'0HALFWIDTH PARAMETERS=',/,3(1X,3F10.6,/),
     *'0CELL PARAMETERS=',/,6(3F11.6,/),
     *'0PREFERRED ORIENTATION PARAMETERS=',/,2(1X,3F8.5,/),
     *'0ASYMMETRY PARAMETER=',/,1X,3F8.5,/,
     *'0LORENTZIAN HALF WIDTH PARAMS (X AND Y) ',/,2(1X,3F8.5,/))
 1017 FORMAT(' OVERALL SCALE FACTOR=',2G9.3,/,
     *       ' ETA(PSEUDO-VOIGT) M (PEARSON VII)= ',2F8.4,/,
     *       ' OVERALL TEMP. FACTOR=',2F9.4,/,
     *       ' HALFWIDTH PARAMETERS=',/,3(1X,2F10.6,/),
     *       ' PREFERRED ORIENTATION PARAMETERS=',4F7.4,/,
     *       ' ASYMMETRY PARAMETER=',2F8.5,/,
     *       ' HALF WIDTH PARAMS (X AND Y)=',/,2(1X,2F8.5,/))
 5017 FORMAT(2G9.3/2F8.4/2F9.4/3(1X,2F10.5,/),2(2F8.5,/)
     *       ,2F8.5,/,2(1X,2F8.5,/)) 
   10 CONTINUE
      DO 19 J=1,11
      IF(NPROF.EQ.8.AND.(J.EQ.8.OR.J.EQ.9)) GO TO 19
      IF(NPROF.EQ.6.AND.J.EQ.8) GO TO 19
      IF(NPROF.EQ.7.AND.J.EQ.8) GO TO 19
      KM=LGLB(J)
      IF(KM.NE.0)GOTO 20
      SY(J)=0.
      SZ(J)=0.
      GOTO 19
   20 SZ(J)=SQRT(ABS(SMM(KM,KM)))
      SY(J)=V(KM)*AGLB(J)*RELAX(4)
      GLB(J)=GLB(J)+SY(J)
   19 CONTINUE
      WRITE(6,109)GLB(1),SY(1),SZ(1)
      IF (YES) THEN
        WRITE(8,1018)GLB(1),SZ(1)
        IF (JCIL.EQ.1) WRITE(2,5018)GLB(1),SZ(1)
      ENDIF
 1018 FORMAT(' ZEROPOINT=',2F8.4)
 5018 FORMAT(2F8.4)
  109 FORMAT('0GLOBAL PARAMETERS',/,'0ZEROPOINT=',3F8.4)
      IF(NBCKGD.NE.0)GOTO 80
      WRITE(6,84)(GLB(J),SY(J),SZ(J),J=2,7)
      IF (YES) THEN
        WRITE(8,1019)(GLB(J),SZ(J),J=2,7)
        IF (JCIL.EQ.1) WRITE(2,5019)(GLB(J),SZ(J),J=2,7)
      ENDIF
 1019 FORMAT(' BACKGROUND PARAMETERS',/,(1X,2G12.6))
 5019 FORMAT((2G12.6))
   84 FORMAT('0BACKGROUND PARAMETERS',/,(1X,3G12.6))
   80 IF(NPROF.NE.5) GOTO 90
      WRITE(6,72)ID(NPROF-4),GLB(8),SY(8),SZ(8)
   72 FORMAT(1X,A10,3F8.4)
      IF(NPROF.GT.5)GOTO 90
      WRITE(6,75)GLB(9),SY(9),SZ(9)
   75 FORMAT(8H EXCESS=,3F8.4)
 90   CONTINUE
      WRITE (6,181) (GLB(J),SY(J),SZ(J),J=10,11)
181   FORMAT (/' SAMPLE DISPLACEMENT (DISP)       ',3F8.4,/,
     }        ' SAMPLE TRANSPARENCY (TRANSP)     ',3F8.4)
      X=100.*SQRT((FLOAT(NUM)-FLOAT(MAXS)+FLOAT(MAXCON))*1./D2)
      CHI2=(R3/X)**2
      FREED=FLOAT(NUM)-FLOAT(MAXS)+FLOAT(MAXCON)
      CCS=FREED+YINV
      DSTAR=DEVINC/CCS
      QDW=2.0*(FLOAT(NUM-1)/FREED-3.0902/SQRT(FLOAT(NUM+2)))
      WRITE(6,57)R2,R3,CHI2,DW
      WRITE(6,58)X,QDW
      WRITE(6,59)DEVINC,DSTAR
      WRITE (6,66) SQRT(S2/FLOAT(NUM))
   66 FORMAT (1X,'R-INDEX',F8.2,5X,'SQRT(RESIDUAL/N)')
 59   FORMAT(/' DEVIANCE= ',G9.3,4X,' DEV*= ',G10.4)
1159  FORMAT(/' DEVIANCE= ',G9.3,4X,' DEV*= ',G10.4/
     &'  DW-STAT.= ',F8.4,'  QDW= ',F8.4)
      WRITE(7,57)R2,R3,CHI2,DW
      WRITE(7,58)X,QDW
   57 FORMAT( 11H0R-FACTORS=,2F8.2,' CHI2= ',G10.4,' DW-STAT.= ',F8.4)
   58 FORMAT(11H EXPECTED =,8X,F8.2,28X,F8.4)
      IF (YES) WRITE(8,1022)ICYCLE,MCYCLE
 1022 FORMAT(/1X,'ICYCLE=',I8,1X,'MAXCYCLE=',I8/)
      IF (YES) THEN
       WRITE(8,1021)R2,R3,X,CHI2,TAF
       WRITE(8,1159)DEVINC,DSTAR,DW,QDW
       IF(JCIL.EQ.1) WRITE(2,5021)R2,R3,X,CHI2,DSTAR
      ENDIF
 1021 FORMAT(/' RP=',F6.2,1X,'RWP=',F6.2,1X,'REXP=',F6.2,1X,
     * 'CHI2= ',G10.4,2X,A4,' REFINEMENT')
 5021 FORMAT(3F8.2,2G10.4)
   60 I=NUM-MAXS+MAXCON
      WRITE(6,62)I
      IF (YES) WRITE(8,62)I
      WRITE(6,63)S1,D1,S3,D2,S2,COND
   62 FORMAT( 7H0N-P+C=,I8)
   63 FORMAT(/,7X,7HSUMYDIF, 7X,7HSUMYOBS, 6X,8HSUMYCALC, 6X,10HSUMWYOBS
     1SQ,6X,8HRESIDUAL,6X,9HCONDITION/1X,6E14.4/)
      RETURN
      END
      SUBROUTINE DIRECT(SM,V,IPH,N)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      COMMON/F1/SMM(MSZ,MSZ),VX(MSZ)
      COMMON/PARAMS/GLB(16),AGLB(16),LGLB(16),PAR(8,20),APAR(8,20),
     *LPAR(8,20),XL(NATS,11),LP(NATS,11),A(NATS,11),
     *PTR(NATS),RELAX(4),RATIO(2)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      DIMENSIONV(6),SM(6,6)
      DO 1 J=1,6
      V(J)=PAR(IPH,J+5)
      K=LPAR(IPH,J+5)
      X=APAR(IPH,J+5)
      IF(K.EQ.0)X=0.
      DO 1 L=J,6
      M=LPAR(IPH,L+5)
      SM(L,J)=0.
      IF((M.EQ.0).OR.(K.EQ.0))GOTO 1
      SM(L,J)=SMM(M,K)*X*APAR(IPH,L+5)
    1 SM(J,L)=SM(L,J)
      CALL ESD(SM,V,1.)
      RETURN
      END
      SUBROUTINE ESD(SM,V,SUM)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      DIMENSION SM(6,6),V(6),S(6),R(6),E(6)
      I=0
      DO 1 IA=1,3
      I=I+1
      IB=IA+1
      IF(IB.GT.3)IB=IB-3
      IC=IB+1
      IF(IC.GT.3)IC=IC-3
      ID=IA+3
      IE=IB+3
      IP=IC+3
      FNUM=4.*V(IB)*V(IC)-V(ID)*V(ID)
      DEN=4.*V(IA)*V(IB)*V(IC)-V(IA)*V(ID)*V(ID)-V(IB)*V(IE)*V(IE)-V(IC)
     1*V(IP)*V(IP)+V(ID)*V(IE)*V(IP)
      S(I)=SQRT(FNUM/DEN)
      R(IA)=-S(I)**4
      DENL=1./(DEN*DEN)
      R(IB)=DENL*(4.*V(IC)*DEN-(4.*V(IA)*V(IC)-V(IE)*V(IE))*FNUM)
      R(IC)=DENL*(4.*V(IB)*DEN-(4.*V(IA)*V(IB)-V(IP)*V(IP))*FNUM)
      R(ID)=-DENL*(2.*V(ID)*DEN-(2.*V(IA)*V(ID)-V(IE)*V(IP))*FNUM)
      R(IE)=DENL*FNUM*(2.*V(IB)*V(IE)-V(ID)*V(IP))
      R(IP)=DENL*FNUM*(2.*V(IC)*V(IP)-V(ID)*V(IE))
      E(I)=ERROR(SM(1,1),R(1),SUM)
      E(I)=E(I)/(2.*S(I))
      FNUM=V(IE)*V(IP)-2.*V(IA)*V(ID)
      DEN=16.*V(IA)*V(IA)*V(IB)*V(IC)+V(IE)*V(IE)*V(IP)*V(IP)-4.*(V(IA)*
     1V(IB)*V(IE)*V(IE)+V(IC)*V(IA)*V(IP)*V(IP))
      DENL=1./(DEN*DEN)
      FNUML=FNUM*FNUM
      S(I+3)=FNUML/DEN
      R(IA)=-4.*FNUM*DENL*(V(ID)*DEN+FNUM*(8.*V(IA)*V(IB)*V(IC)-V(IB)*V(
     1IE)*V(IE)-V(IC)*V(IP)*V(IP)))
      R(IB)=-4.*FNUML*DENL*(4.*V(IA)*V(IA)*V(IC)-V(IA)*V(IE)*V(IE))
      R(IC)=-4.*FNUML*DENL*(4.*V(IA)*V(IA)*V(IB)-V(IA)*V(IP)*V(IP))
      R(ID)=-4.*FNUM/DEN*V(IA)
      R(IE)=2.*FNUM*DENL*(V(IP)*DEN-FNUM*(V(IE)*V(IP)*V(IP)-4.*V(IA)*V(I
     1B)*V(IE)))
      R(IP)=2.*FNUM*DENL*(V(IE)*DEN-FNUM*(V(IE)*V(IE)*V(IP)-4.*V(IC)*V(I
     1A)*V(IP)))
      E(I+3)=ERROR(SM(1,1),R(1),SUM)
      IF(S(I+3).EQ.0.0) GOTO 3
      E(I+3)=E(I+3)/(2.*SQRT(S(I+3)*(1.-S(I+3))))*180./3.14159265359
      S(I+3)=ATAN(SQRT((1.-S(I+3))/S(I+3)))*180./3.14159265359
      GOTO 4
    3 S(I+3)=90.
      E(I+3)=0.0
    4 CONTINUE
      IF(FNUM.LT.0.)S(I+3)=180.-S(I+3)
      IF(SM(ID,ID).EQ.0.)E(ID)=0.
    1 CONTINUE
      IF(ABS(S(1)-S(2)).LT..00008)E(1)=E(2)
      DO 2 I=1,6
      SM(I,I)=E(I)
    2 V(I)=S(I)
      RETURN
      END
      FUNCTION ERROR(A,B,OMEGA)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      DIMENSION A(6,6),B(6)
      SUM=0.
      DO 1 I=1,6
      DO 1 J=I,6
      X=2.
      IF(I.EQ.J)X=1.
    1 SUM=SUM+A(I,J)*B(I)*B(J)*X
      IF(SUM.LT.0.)SUM=0.
      ERROR=SQRT(SUM*OMEGA)
      RETURN
      END
      SUBROUTINE STEEP(X,N,M,CHISQ,GRAD)
      PARAMETER (IDSZ=65536,IRS=8192,NATS=128,MSZ=256,NOV=800)
      DIMENSION Z(16),X(16),T(16),ZNT(16),SIGT(16),SIG(16)
      DIMENSION Y(16,16),XI(16),ZN(16)
      IF(N.EQ.0)RETURN
      CALL GRAD(X,Z)
      CALL CHISQ(X,G)
      DO 10 I=1,M
      DO 10 J=1,M
      Y(I,J)=0.0
      IF(I.EQ.J)Y(I,J)=1.0
   10 CONTINUE
      DO 200 K=1,N
      U=0
      DO 20 I=1,M
      T1=0
      DO 30 J=1,M
   30 T1=T1+Z(J)*Y(I,J)
      SIG(I)=T1
   20 U=U-SIG(I)*Z(I)
      ETA=AMIN1(1.0,ABS(2.*G/U))
      DO 40 I=1,M
   40 T(I)=X(I)-ETA*SIG(I)
      CALL GRAD(T,ZN)
      V=0
      DO 50 I=1,M
   50 V=V-ZN(I)*SIG(I)
      CALL CHISQ(T,G1)
      D=3.*ABS(G-G1)/ETA+U+V
      W=SQRT(D*D-U*V)
      ALPHA=ETA*(1.-(V+W-D)/(V-U+2.*W))
      DO 60 I=1,M
      SIG(I)=-1.0*ALPHA*SIG(I)
      X(I)=X(I)+SIG(I)
   60 ZN(I)=Z(I)
      CALL GRAD(X,Z)
      CALL CHISQ(X,G)
      T1=0
      DO 70 I=1,M
      XI(I)=Z(I)-ZN(I)
   70 T1=T1+XI(I)*SIG(I)
      DO 80 I=1,M
   80 SIGT(I)=SIG(I)/T1
      T1=0
      DO 90 I=1,M
      T2=0
      DO 100 J=1,M
  100 T2=T2+XI(J)*Y(I,J)
      ZN(I)=T2
   90 T1=T1+ZN(I)*XI(I)
      DO 110 I=1,M
      T2=0
      DO 120 J=1,M
  120 T2=T2+XI(J)*Y(J,I)
  110 ZNT(I)=T2/T1
      DO 131 I=1,M
      DO 130 J=1,M
  130 Y(I,J)=Y(I,J)+SIG(I)*SIGT(J)-ZN(I)*ZNT(J)
  131 CONTINUE
  200 CONTINUE
      RETURN
      END
